<?
################################
# THIS FUNCTION:
#   1. DOWNLOADS THE HEADER FILE FOR A WEB PAGE
#	2. LOOKS FOR AND RETURNS HTTP REDIRECT IF FOUND
#
#   USAGE: 
#	get_first_page("www.evample.com");
################################
#
function get_first_page($URL)
	{

	# ASSUMES YOUR CURL INSTALLATION IS AT "C:\curl
	$header = `c:\curl\curl --head $URL`;
	$parsed = inclusive_parse($string=$header, $start="Location: ", $end="\n", $max_span=50);
	return $parsed[0];
	}

################################
# THIS FUNCTION:
#   1. CLEANS UP A LINK, THAT IS DELIMITTED WITH EITHER (")'s or (')'s
#	2. RETURNS CLEANED UP LINK
#
#   USAGE: 
#	clean_link_file($dirty_link);
################################
#
function clean_link_file($dirty)
	{		
	$data = str_replace("\"", "'", $dirty);

	$first_quote_found=FALSE;
	$cleaned="";
	for ($yy=0; $yy<strlen($data); $yy++)
		{
		if ($data[$yy]=="'" && $first_quote_found) {
			break;
			}
		if ($data[$yy]=="'" && !$first_quote_found) {
			$first_quote_found=TRUE;
			}
		if ($data[$yy]!="'" && $first_quote_found) {
			$cleaned=$cleaned.$data[$yy];
			}
		}
	return $cleaned;
	}	
	
	
################################
# THIS FUNCTION:
#   1. RETURNS UP TO $max_span CHARACTER BETWEEN $start AND $end 
#      AS FOUND IN $string
#	2. RETURNS AN ARRAY OF EVERY MATCHING PATTERN
#
#   USAGE: 
#	$array = inclusive_parse($string, $start, $end, $max_span);
################################
#
function inclusive_parse($string, $start, $end, $max_span)
	{
	$search_string = $string;

	# ELIMINATE EVERYTHING UPTO THE START CRITERIA
	while( $found  = stristr($search_string, $start))
		{
		# LOOK FOR THE END CRITERIA, WITHOUT GOIGN BEYOND MAX_SPAN CRITERIA
		for ($xx=0; $xx<$max_span; $xx++)
			{
			if ($found[$xx] == $end) {
				break;
				}
			}

		# GATHER EVERYTHING BETWEEN START AND END SEARCH CRITERIA 
 		$data = substr($found, strlen($start), $xx-strlen($start));

		# PUSH IT INTO AN ARRAY
 		$array[] = $data;

		# REDUCE AMOUNT LEFT TO TO AND START AGAIN
		$search_string = substr($found, strlen($start)+$xx);
		}

	return $array;
	}

#############################################
# N O T E : 
# THIS CODE WAS DESIGNED TO BE RUN FROM A COMMAND LINE
# IT WILL LOOK WEIRD IF RUN IN A BROWSER
#############################################

#############################################
# SAMPLE TABLE FOR TABLE PARSE DEMONSTRATION
# IN REAL LIFE, THIS WOULD BE DOWNLOADED FROM 
# A WEB PAGE

$data = "<table border=\"2\" bgcolor=\"white\">
			<TR>
				<th>Name</th><th>Phone</th><th>Zip</th>
			</tr><tr>	
				<td>Donna</td><td>(800) 555-1321</td><td>55423</td>
			</tr><tr>	
				<td>Mark</td><td>(976) 555-3323</td><td>55427</td>
			</tr><tr>	
				<td>Tom</td><td>(555) 555-1199</td><td>55429</td>
			</TR>
		</table>";
#############################################

# SET TABLE ROW END TAG TO KNOWN VALUE
$data = str_replace("</TR>", "</tr>", $data);

# PARSE TABLE ROWS INTO ARRAY, USE CLOSING TAG TO AVOID CONFUSION CAUSED BY TAG ATTRIBUTES
$table_array = explode("</tr>", $data);
$qty_rows = count($table_array);

	for($row=0; $row<$qty_rows-1; $row++)
		{
		# SET TABLE DATA CELL END TAG TO KNOWN VALUE
		$table_array[$row] = str_replace("</TD>", "</td>", $table_array[$row]);
		$table_array[$row] = str_replace("</TH>", "</td>", $table_array[$row]);
		$table_array[$row] = str_replace("</th>", "</td>", $table_array[$row]);

		# PARSE TABLE COLUMNS INTO ARRAY, USE CLOSING TAG TO AVOID CONFUSION CAUSED BY TAG ATTRIBUTES
		$row_array = explode("</td>", $table_array[$row]);

		# CLEAN UP PARSED DATA AND DISPLAY
		echo "Row=$row\n";
		for ($yy=0; $yy<count($row_array)-1; $yy++)
			{
			$row_array[$yy] = strip_tags($row_array[$yy]);
			$row_array[$yy] = trim($row_array[$yy]);
			echo "row_array=$row_array[$yy]\n";
			}
		}


?>
